/*
 *   .
 *
 *   ,    
 *    ,     .
 */
extern const unsigned char _ctype_ [257];

#define	_U	0x01
#define	_L	0x02
#define	_N	0x04
#define	_S	0x08
#define	_P	0x10
#define	_C	0x20
#define	_X	0x40
#define	_E	0x80

/*
 * ,     0..9.
 */
static inline unsigned char
isdigit (int c)
{
	return FETCH (_ctype_+1+c) & _N;
}

/*
 * ,      ,
 * ..     : 0..9 a..f A..F.
 */
static inline unsigned char
isxdigit (int c)
{
	return FETCH (_ctype_+1+c) & (_N | _X);
}

/*
 *      
 *  a..z A..Z 0240..0377.
 */
static inline unsigned char
isalpha (int c)
{
	return FETCH (_ctype_+1+c) & (_U | _L | _E);
}

/*
 * ,       a..z.
 */
static inline unsigned char
islower (int c)
{
	return FETCH (_ctype_+1+c) & _L;
}

/*
 * ,       A..Z.
 */
static inline unsigned char
isupper (int c)
{
	return FETCH (_ctype_+1+c) & _U;
}

/*
 *      
 *  0..9 a..z A..Z 0240..0377.
 */
static inline unsigned char
isalnum (int c)
{
	return FETCH (_ctype_+1+c) & (_U | _L | _E | _N);
}

/*
 *    .
 *     a..z,  .
 */
static inline unsigned char
toupper (int c)
{
	return c + 'A' - 'a';
}

/*
 *    .
 *     A..Z,  .
 */
static inline unsigned char
tolower (int c)
{
	return c + 'a' - 'A';
}

/*
 * ,    ,  :
 * ,    \f, " " \n,
 * " " \r, " " \t 
 * " " '\v'.
 */
static inline unsigned char
isspace (int c)
{
	return FETCH (_ctype_+1+c) & _S;
}

/*
 * ,    ;  
 *      .
 */
static inline unsigned char
ispunct (int c)
{
	return FETCH (_ctype_+1+c) & _P;
}

/*
 * ,    .
 *    isprint()   EOF.
 */
static inline unsigned char
iscntrl (int c)
{
	return FETCH (_ctype_+1+c) & _C;
}

/*
 * ,     ( ).
 *    iscntrl()   EOF.
 */
static inline unsigned char
isprint (int c)
{
	return FETCH (_ctype_+1+c) & (_P | _U | _L | _E | _N | _S);
}

/*
 * ,     ( ).
 *    isspace(),  iscntrl()   EOF.
 */
static inline unsigned char
isgraph (int c)
{
	return FETCH (_ctype_+1+c) & (_P | _U | _L | _E | _N);
}

#undef	_U
#undef	_L
#undef	_N
#undef	_S
#undef	_P
#undef	_C
#undef	_X
#undef	_E
