/*
 * void assert (int expression);
 *
 * If NDEBUG is defined, do nothing.
 * If not, and EXPRESSION is zero, print an error message and abort.
 */
#ifdef NDEBUG

#define assert(expr)		((void) 0)

#else /* Not NDEBUG */

/* This prints an "Assertion failed" message and aborts. */
void __assert_fail (const char *expr, const char *file, unsigned int line,
	const char *func) __attribute__ ((__noreturn__));

#define assert(expr) ((void) ((expr) ? 0 : __assert_fail (#expr, \
	__FILE__, __LINE__, __PRETTY_FUNCTION__), 0))

#endif /* NDEBUG */
