#include <runtime/lib.h>
#include <kernel/uos.h>
#include <kernel/internal.h>

void
debug_print_task (task_t *t)
{
	lock_t *m;

	if (! t) {
		/* Print only header. */
		debug_printf ("Task\tAddress\t\tPrio\tSP\t\tMsg\tFin\n");
		return;
	}
	debug_printf ("%s\t%08lx\t", t->name, (long) t);
	debug_printf (t == task_current ? "*%d*" : "%d", t->prio);
	debug_printf ("\t%08lx\t%p\n",
		(long) t->stack_context, t->message);
	if (t->lock)
		debug_printf ("\tLocked by %p\n", t->lock);
	if (t->wait)
		debug_printf ("\tWaiting for %p\n", t->lock);
	if (t->slaves.head) {
		debug_printf ("\tOwning:");
		for (m=t->slaves.head; m; m=m->next)
			debug_printf (" %p", m);
		debug_printf ("\n");
	}
}
