#include <runtime/lib.h>

/* Compare no more than N characters of S1 and S2,
   ignoring case, returning less than, equal to or
   greater than zero if S1 is lexicographically less
   than, equal to or greater than S2.  */
int
strncasecmp (const char *s1, const char *s2, mem_size_t n)
{
	const unsigned char *p1 = (const unsigned char*) s1;
	const unsigned char *p2 = (const unsigned char*) s2;
	unsigned char c1, c2;
	int result;

	if (p1 == p2 || n == 0)
		return 0;

	do {
		c1 = *p1++;
		c2 = *p2++;
		if (isupper (c1))
			c1 = tolower (c1);
		if (isupper (c2))
			c2 = tolower (c2);

		result = c1 - c2;
		if (result != 0)
			return result;

	} while (c1 != '\0' && --n > 0);

	return 0;
}
